html {
    font-family: sans-serif;
}

body {
    margin: 0;

    height: 100vh;
    width: 100vw;

    display: grid;
    grid-template-columns: min-content minmax(50vw, 1fr);
    grid-template-rows: 50% 50%;
    grid-template-areas:
        "video top-pane   "
        "video bottom-pane";
}

body>div {
    display: flex;
    flex-direction: column;
}

button {
    font-size: 100%;
    border: none;
    padding: .2em .4em;
    border-radius: .2em;
    cursor: pointer;
}

button:disabled {
    cursor: not-allowed;
}

/* navbar */

.navbar {
    min-height: 2.5em;
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    padding: .2em .4em;
    align-items: center;
    font-size: 120%;
}

.navbar .buttons {
    display: flex;
    flex-direction: row;
    gap: .5em;
}

.navbar .buttons button {
    padding: .4em .8em;
}

/* dropdown buttons */

.dropdown {
    max-width: 13em;
    position: relative;
}

.dropdown-btn {
    justify-content: space-between;
    align-items: center;
}

.dropdown-content {
    visibility: hidden;

    position: absolute;
    right: 0;
    top: 2.5em;

    z-index: 100;
    width: max-content;
    overflow: hidden;

    display: flex;
    flex-direction: column;
    gap: .5em;
}

.dropdown:focus-within .dropdown-content {
    visibility: visible;
}

.dropdown button {
    color: #555;
}

.dropdown button:hover {
    background-color: #888;
    color: white;
}

/* video */

#video {
    grid-area: video;
    align-items: center;
    background-color: #222;
}

#video video {
    max-height: 100vh;
    max-width: 50vw;
    flex-grow: 1;
    /* without it, the video is inline
     * and it overflows its container to make space for letter descenders!
     * thanks https://stackoverflow.com/a/34752109/3025740
    */
    display: block;
}

/* starting code pane */

#starting-code-pane {
    grid-area: top-pane;
    background-color: rgb(232, 240, 252);
    color: rgb(13, 37, 69);
}

#starting-code-pane .navbar {
    background-color: rgb(182, 209, 237);
    color: rgb(102, 122, 171);
}

#starting-code-pane pre {
    padding: 1.2em 0.4em;
    font-size: .85rem;
    margin: 0;
    overflow: scroll;
}

/* editor pane */

#editor-pane {
    grid-area: top-pane;
    background-color: #DDD;
}

#editor {
    flex-grow: 1;
}

#run-btn {
    background-color: #C6EBB6;
    color: #487424;
}

#run-btn:hover {
    background-color: #3bb600;
    color: #fff;
}

/* console pane */

#console-pane {
    background-color: #444;
}

#console-pane .navbar {
    background-color: #666;
    color: white;
}

#console {
    font-family: monospace;
    color: white;
    overflow-x: scroll;
    font-size: .8rem;
}

#console:focus {
    outline: none;
}

/* search engine pane */

#search-engine-pane {
    grid-area: bottom-pane;
}

#search-engine-pane .navbar {
    background-color: #5CA1CF;
    color: white;
}

#web-app-not-launched {
    background-color: #DDD;
    height: 100%;
    font-size: large;
    color: #666;
    text-align: center;
    display: flex;
    flex-direction: column;
    justify-content: center;
}

#search-engine-pane a {
    color: #1f4cff
}

#search-engine-pane a:hover {
    color: #022cd4
}

#search-engine-page,
#db-page {
    display: flex;
    flex-direction: column;
    margin-top: 2em;
    align-content: center;
    align-items: center;
    padding-bottom: 2em;
}

#search-engine-page> :not(nav),
#db-page> :not(nav) {
    width: min(50em, 95%);
}

#web-app {
    overflow-x: scroll;
}

#web-app a.nav {
    padding: .8em;
    color: #666;
    text-decoration: none;

    /* XXX this should not be in "#web-app a" */

    align-self: flex-end;
    width: max-content;
    margin: 0;
}

#web-app a:hover {
    color: #0D60E2;
}

#web-app-error {
    background-color: #FFE9E9;
    height: 100%;
    color: #950000;
    padding: .5em;
    overflow-x: scroll;
}

#search-engine-page h3 {
    font-size: 250%;
    text-align: center;
    font-weight: normal;
    margin-bottom: 0.5em;
    color: #555;
}

#search-engine-page #search-form {
    display: flex;
    justify-content: center;
}

#search-engine-page #search-form button {
    margin-left: 0.5em;

    padding: .4em .8em;
    font-size: 120%;
    background-color: #CEEAFF;
    color: #295B90;
}

#search-engine-page #search-form button:hover {
    background-color: #2F88E6;
    color: #EEF6FF;
}

#search-engine-page #search-results {
    text-align: left;
    margin-top: 2em;
    width: min(50em, 80%);
    margin-left: auto;
    margin-right: auto;
}

#search-engine-page #search-results ul {
    display: flex;
    flex-direction: column;
    gap: 1em;
    align-items: stretch;
    padding: 0;
}

#search-engine-page #search-results ul li {
    list-style-type: none;
}

.disabled-info {
    background-color: rgba(250, 250, 250, 0.83);
    display: flex;
    align-items: center;
    justify-content: center;
    color: #444;
    padding: .5em;
    box-sizing: border-box;
}

#db-page #doc-list ul {
    padding: 0;
}

#db-page #doc-list>ul {
    display: flex;
    flex-direction: column;
    gap: 1.5em;
}

#db-page #doc-list ul li {
    list-style-type: none;
}

#index .content ul {
    padding: 0;
}

#index .content li {
    list-style-type: none;
    margin: .2em 0em;
}

/* export pane */

#export-pane {
    grid-area: bottom-pane;
    background-color: whitesmoke;
    z-index: 10;
}

#export-pane>.navbar {
    background-color: white;
    color: #444;
}

#export-pane form {
    padding: .5em;
    max-width: 40em;
    margin: auto;
    margin-top: 1em;
    display: flex;
    flex-direction: column;
    gap: 1em;
}

#export-pane form input {
    font-size: 100%;
    padding: .2em .3em;
}

#export-pane form button {
    align-self: self-end;
    padding: .4em .6em;
    background-color: #dfdfdf;
}

#export-pane form button:hover {
    background-color: #d0d0d0;
}